unit uTurtle0;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs,mTTurtleWelt, StdCtrls;

type
  TForm1 = class(TForm)
    bZeichneNEck: TButton; Memo1: TMemo; bRt30: TButton; bFd100: TButton;
    bBk100: TButton; bSt: TButton; bHT: TButton; bPu: TButton; bPd: TButton;
    eR: TEdit;
    lR: TLabel;
    eAlpha: TEdit;
    lAlpha: TLabel;
    bArc: TButton;
    eD: TEdit;
    lD: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure bZeichneNEckClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure bRt30Click(Sender: TObject);
    procedure bFd100Click(Sender: TObject);
    procedure bBk100Click(Sender: TObject);
    procedure bStClick(Sender: TObject);
    procedure bHTClick(Sender: TObject);
    procedure bPuClick(Sender: TObject);
    procedure bPdClick(Sender: TObject);
    procedure bArcClick(Sender: TObject);
  private
    TW : TTurtleWelt;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

  procedure warte(t: longint);
  var
    a: longint;
  begin
    a := GetTickCount;
    repeat
      Application.ProcessMessages;
    until (GetTickCount > a+t);
  end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  TW := TTurtleWelt.Create(-512,512,-384,384,canvas,width,height);
  // DEBUG
  memo1.Lines.Add(IntToStr(height));
  // DEBUG
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  TW.Free;
end;

procedure TForm1.bZeichneNEckClick(Sender: TObject);
const
  n = 5;
  a = 200;
var
  i : integer;
begin
  for i := 1 to n do
  begin
    TW.fd(a);warte(500);
    TW.lt(360/n); warte(500);
  end;
  // DEBUG
  memo1.Lines.Add(FloatToStr(TW.GetX));
  memo1.Lines.Add(FloatToStr(TW.GetY));
  memo1.Lines.Add(FloatToStr(TW.GetW));
  // DEBUG
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  TW.st;
end;

procedure TForm1.bRt30Click(Sender: TObject);
begin
  TW.rt(30);
end;

procedure TForm1.bFd100Click(Sender: TObject);
begin
  TW.fd(100);
end;

procedure TForm1.bBk100Click(Sender: TObject);
begin
  TW.bk(100);
end;

procedure TForm1.bStClick(Sender: TObject);
begin
  TW.st;
end;

procedure TForm1.bHTClick(Sender: TObject);
begin
  TW.ht;
end;

procedure TForm1.bPuClick(Sender: TObject);
begin
  TW.pu;
end;

procedure TForm1.bPdClick(Sender: TObject);
begin
  TW.pd;
end;

procedure TForm1.bArcClick(Sender: TObject);
var
  r,alpha : real;
  d       : shortint;
begin
  r     := StrToFloat(eR.Text);
  alpha := StrToFloat(eAlpha.Text);
  d     := StrToInt(eD.Text);
  TW.arc(r,alpha,d);
end;

end.
